############################################################################
# Copyright (C) 2002 David Lucardi
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.
############################################################################
# File  : fichier.php
# Author  : David Lucardi
#           mailto: DavidLucardi@aol.com
# Date    : 26/04/2002
# Licence : GNU/GPL Version 2 ou plus
#
# Description:
# ------------
#
# @version
# @author     David Lucardi
# @project
# @copyright  David Lucardi 26/04/2002
#
#
#########################################################################
#!/bin/sh
#bilan.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}


set c .frame.c
set bgn #ffff80
set bgl #ff80c0
source msg.tcl
source fonts.tcl
  global env
 source path.tcl
set plateforme $tcl_platform(platform) ; set ident $tcl_platform(user)
init $plateforme
initlog $plateforme  $ident
if { $tcl_platform(platform)  == "unix" } {
if {[catch { set f [open [file join ${user}  ] "r"  ] }] }  {
   set answer [tk_messageBox -message [mc {Erreur de fichier}] -type ok -icon info]
   exit
   }
 }
 ## set f  [ open  [file join $user  ]  "r" ]
. configure -background black -width 640 -height 480
wm geometry . +0+0
 if { $tcl_platform(platform) == "windows" } {
set types {
	{"Catgories"		{.log}	}
         }
catch {set file [tk_getOpenFile -initialdir $LogHome -filetypes $types]}
if {[catch { set f [open [file join $file] "r" ] }] } {
     set answer [tk_messageBox -message [mc {err_fich}] -type ok -icon info]
     exit
     }
}

wm title . "Bilan\040 de [lindex [split [lindex [split $user /] end] .] 0]"
text .text -yscrollcommand ".scroll set" -setgrid true -width 60 -height 20 -wrap word -background black -font   {Helvetica  12}
##$sysFont(l)
scrollbar .scroll -command ".text yview"
pack .scroll -side right -fill y
pack .text -expand yes -fill both

.text tag configure green -foreground green
.text tag configure red -foreground red
.text tag configure yellow -foreground yellow
.text tag configure normal -foreground black
.text tag configure white -foreground white

      while {![eof $f]}  {
           set listeval [gets $f]
	   if { $listeval == "" } {
	   continue
	   }
	     set liste_plate [split $listeval : ]
          set  date [lindex $liste_plate 0 ]  ;    set  nom  [lindex $liste_plate 1 ]
        set  nom_exo   [lindex $liste_plate 2 ]  ;     set  oper   [lindex $liste_plate 3 ]
          set  bonne_liste   [lindex $liste_plate 4 ]
         set  liste_troptard    [lindex $liste_plate 5 ]  ;  set  mrep_ou_echecs [lindex $liste_plate 6 ]
         set logiciel [lindex $liste_plate 7 ] 
         if { $logiciel == "ap" } {
         set approx [lindex  $mrep_ou_echecs 0] ;  set n_mrep [lindex   $mrep_ou_echecs 1]
         set message " [ format [mc {avec une approximation de : %1$s et liste d'erreurs  de %2$s}] $approx ${n_mrep}]"
         }
         if { $logiciel == "pl" } {
         set message "[mc {nbre_max_err}] $mrep_ou_echecs"
        }
       if { $logiciel == "un" } {
         set message "[mc {list_err}]\n  $mrep_ou_echecs"
        }

             .text insert end  "${date} par  ${nom} pour l'exercice : ${nom_exo}. Opration : ${oper}\n"  white
             .text insert end  "[mc {bon_calc}] \n ${bonne_liste}\n"     red
             .text insert end " [mc {trop_tard}]\n ${liste_troptard}\n $message\n"  green
             .text insert end "============================================================\n"  white
         }


close $f













