#!/bin/sh
#choix.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}
#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#**************************************************************************
#  File  : $$$
#  Author  : jean-louis.sendral@toulouse.iufm.fr
#  Modifier: andre.connes@toulouse.iufm.fr
#  Date    : 24/04/2002
#  Licence : GNU/GPL Version 2 ou plus
#
#  Description:
#  ------------
#
#  @version
#  @author     Jean- Louis Sendral
#  @modifier   Andre Connes
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
#
#  *****************************************

#############Prparation du calcul : nom, classe, choix du scnario ou de la squence.

###################"gestion du son
#"global sound
#"if {[catch {package require -exact snack 2.1}]} {
#"    set sound 0
#"} else {
#"    set sound 1
#"}

set basedir [pwd]
# [file dirname $argv0]
cd $basedir
source calculs.conf
source path.tcl
set basedir [pwd]
#source i18n
# #########################################################################
# internationalisation (c) andre.connes@toulouse.iufm.fr
# le fichier i18n, inclus par la commande "source i18n", contient par exemple
#    set i18n(fr,hello) "Bonjour..."
#    set i18n(uk,hello) "Hello..."
# appel   : set message [gettext hello]
# ou bien : puts stdout [gettext hello]
# #########################################################################
#proc gettext { m } {
#  global LG i18n
#  if { [info exists i18n($LG,$m)] } {
#    return $i18n($LG,$m)
#  } elseif { [info exis
#  ts i18n(fr,$m)] } {
#    return $i18n(fr,$m)
#  } else {
#    return "err.i18n_$LG : \"$m\" needed."
#  }
#} ;# proc gettext

if { [catch {package require Iwidgets}] == 1} {
tk_messageBox -message "Il est ncessaire d'installer le package Iwidgets pour que le menu aide fonctionne" -type ok -title "A nous les nombres"
}

proc showaide {signet} {
catch {
option add *textBackground seashell

set win [iwidgets::hyperhelp .#auto -title "Aide" -modality none -topics {aide}]
    $win showtopic aide#$signet
    $win activate
}
}

bind . <F1> "showaide {division}"
global sysFont
source msg.tcl
source fonts.tcl
global scenario
wm geometry . +0+0
wm title . [mc {choix_sce}]
. configure  -height 480 -width 640
frame .frame -background #aaaaaa -height 480 -width 340
grid .frame -column 0 -row 0

label .frame.lab_prenom -text [mc {nom}] -background #aaaaaa 
place .frame.lab_prenom -x 130 -y 5
entry .frame.ent_nom -justify center
place .frame.ent_nom -x 80 -y 25
focus .frame.ent_nom
#set nom_elev $tcl_platform(user)
#[exec  id -u -n ]
#.frame.ent_nom insert end $nom_elev
#set nom_elev [.frame.ent_prenom get]
label .frame.lab_classe -text [mc {classe}] -background #aaaaaa
place .frame.lab_classe -x 130 -y 50
entry .frame.ent_classe -justify center
place .frame.ent_classe -x 80  -y 70
#set nom_classe [.frame.ent_classe get]
label .frame.t_reglage -text [mc {fich_syst_util}] -background #aaaaaa
place .frame.t_reglage  -x 30 -y 95
radiobutton .frame.reglages -variable choix_lieu -value s -text [mc {commun}] -background #aaaaaa -command "peuplelist1"
place .frame.reglages -x 45 -y 115
radiobutton .frame.reglageu -variable choix_lieu -value u -text [mc {utilisateur}] -background #aaaaaa -command "peuplelist1"
place .frame.reglageu -x 125 -y 115
if { $tcl_platform(platform) == "windows" } {
.frame.reglageu configure -state disable
}
radiobutton .frame.reglagee -variable choix_lieu -value e -text [mc {exemple}] -background #aaaaaa -command "peuplelist1"
place .frame.reglagee -x 212 -y 115
.frame.reglages select

if { $tcl_platform(platform) == "unix" } {
set nom_elev $tcl_platform(user)
set nom_classe [lindex [exec  id -G -n ] 1]
} else {
 set nom_elev eleve
 set nom_classe classe
}
.frame.ent_nom insert end $nom_elev
.frame.ent_classe insert end  $nom_classe
listbox .frame.list1 -background #c0c0c0 -height 10 -width 20 -yscrollcommand ".frame.scroll1 set"
scrollbar .frame.scroll1 -command ".frame.list1 yview"
place .frame.list1 -x 80 -y 195
place .frame.scroll1 -x 208 -y 195 -height 175
label .frame.menu3 -text [mc {double_clic_sce_seq}]  -background #aaaaaa
place .frame.menu3 -x 15 -y 160
label .frame.scenario -text [mc {sce_seq}] -background #aaaaaa
place .frame.scenario -x 85 -y 175
bind .frame.list1 <Double-ButtonRelease-1> { calc }
#pour lister les scnarios et les squences dj construits.
proc dans { el liste } {
foreach el_gen $liste {
if { $el_gen == $el } {
return 1
}
}
return 0
}




proc peuplelist1 {} {
 global DOSSIER_EXOS_DIV   basedir choix_lieu   Home  DOSSIER_EXOS
  if { $choix_lieu == "s" } {
  set DOSSIER_EXOS   $DOSSIER_EXOS_DIV
}
if { $choix_lieu == "u" } {
set DOSSIER_EXOS [file join $Home data]
}
 if { $choix_lieu == "e" } {
set DOSSIER_EXOS [file join $basedir data]
}
cd $DOSSIER_EXOS
.frame.list1   delete 0 end
if {[catch {set f [open [file join scenarios_div.conf] "r"]}]} {
        bell
        return
   	 } else {
	set liste_noms {}
	while { [gets $f ligne] >=0 } {
 	set liste_noms [linsert $liste_noms 0 [lindex [split $ligne ":"] 0]]
	}
close $f
set liste_noms [lsort $liste_noms ]
set liste_sans_doublons {}
foreach nom $liste_noms {
if { ![dans $nom $liste_sans_doublons] } {
set liste_sans_doublons [linsert $liste_sans_doublons 0 $nom ]
.frame.list1 insert end $nom
  
 }
}
}
cd $basedir
}
peuplelist1

proc calculs {} {
return [.frame.list1 get active]
}

proc  calc {} {
global basedir DOSSIER_EXOS_DIV choix_lieu   iwish DOSSIER_EXOS Home
 set fich [calculs]
exec  $iwish  [file join $basedir  division.tcl ] $fich  [.frame.ent_nom  get] [.frame.ent_classe get] $choix_lieu
# destroy . 
} ;#"return [.frame.list1 get active]

