#!/bin/sh
#editeurp.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}
#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#**************************************************************************
#  File  : $$$
#  Author  : jlsendral@free.fr
#  Modifier:
#  Date    : 24/04/2002
#  Licence : GNU/GPL Version 2 ou plus
#
#  Description:
#  ------------
#
#  @version
#  @author     Jean- Louis Sendral jlsendral@free.fr
#  @modifier   Andre Connes
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
#
#  *************************************************************************
source calculs.conf
source i18n
source path.tcl
###################"gestion du son
#"global sound
#"if {[catch {package require -exact snack 2.1}]} {
#"    set sound 0
#"} else {
#"    set sound 1
#"}



# #########################################################################
# internationalisation (c) andre.connes@toulouse.iufm.fr
# le fichier i18n, inclus par la commande "source i18n", contient par exemple
#    set i18n(fr,hello) "Bonjour..."
#    set i18n(uk,hello) "Hello..."
# appel   : set message [gettext hello]
# ou bien : puts stdout [gettext hello]
# #########################################################################
#proc gettext { m } {
#  global LG i18n
#  if { [info exists i18n($LG,$m)] } {
#    return $i18n($LG,$m)
#  } elseif { [info exists i18n(fr,$m)] } {
#  return $i18n(fr,$m)
#  } else {
#    return "err.i18n_$LG : \"$m\" needed."
#  }
# } ;# proc gettext

. configure  -height 440 -width 640 -background #aaaaaa
##wm resizable . 0 0
if { [catch {package require Iwidgets}] == 1} {
tk_messageBox -message "Il est ncessaire d'installer le package Iwidgets pour que le menu aide fonctionne" -type ok -title "Calculs"
}
proc showaide {signet} {
catch {
option add *textBackground seashell

set win [iwidgets::hyperhelp .#auto -title "Aide" -modality none -topics {aide}]
    $win showtopic aide#$signet
    $win activate
}
}
bind . <F1> "showaide cmental"
global sysFont     DOSSIER_EXOS1
source msg.tcl
source fonts.tcl
set  DOSSIER_EXOS1 [file join $Home data]
########## Construction des widgets de l'interface###########
 set basedir [pwd]
 ##cd $DOSSIER_EXOS
#frame1 pour lister les scnarios, ajouter des noms de scnarios qu' il reste  construire, supprimer
#supprimer des scnarios. des scnarios
wm geometry . +0+0
wm title . [mc {Editeur de Scnario}]
frame .frame1 -background #aaaaaa -height 440 -width 320
grid .frame1 -column 0 -row 0
listbox .frame1.list1 -background #c0c0c0 -height 10 -width 20 -yscrollcommand ".frame1.scroll1 set"
scrollbar .frame1.scroll1 -command ".frame1.list1 yview"
place .frame1.list1 -x 60 -y 100
place .frame1.scroll1 -x 188 -y 100 -height 172
label .frame1.menu3 -text [mc {Double_clic_scena}] -background #aaaaaa
place .frame1.menu3 -x 35 -y 75
label .frame1.categorie -text [mc {Scnarios}]
place .frame1.categorie -x 95 -y 10

label .frame1.t_reglage -text [mc {fich_syst_util}] -background #aaaaaa
place .frame1.t_reglage  -x 20 -y 25
radiobutton .frame1.reglages -variable choix_lieu -value s -text [mc {commun}] -background #aaaaaa -command "peuplelist1"
place .frame1.reglages -x 10 -y 45
radiobutton .frame1.reglageu -variable choix_lieu -value u -text [mc {utilisateur}] -background #aaaaaa -command "peuplelist1"
place .frame1.reglageu -x 93 -y 45
if { $tcl_platform(platform) == "windows" } {
.frame1.reglageu configure -state disable
}
 radiobutton .frame1.reglagee -variable choix_lieu -value e -text [mc {exemple}] -background #aaaaaa -command "peuplelist1"
place .frame1.reglagee -x 185 -y 45
.frame1.reglages select


label .frame1.menu1 -text [mc {ajout_supp_scena}] -background #aaaaaa
place .frame1.menu1 -x 25 -y 270
button .frame1.ajouter -text [mc {Ajouter}]
place .frame1.ajouter -x 140 -y 315
button .frame1.supprimer -text [mc {Supprimer} ]
place .frame1.supprimer -x 60 -y 315
entry .frame1.text1
place .frame1.text1 -x 60 -y 290
set message "[mc {dabord}] :\n1\) [mc {tap_nom_sce}]\n2) [mc {clic_ajsup}]\n3) [mc {double_clic_nom}]."
message  .frame1.consigne -text $message -foreground red  -aspect 300
place .frame1.consigne -x 30 -y 345
#frame2 pour diter des scnarios existant, donc les modifier, ou  construire.
frame .frame2 -background #aaaaaa -height 440 -width 320
grid .frame2 -column 1 -row 0
label .frame2.oper -text [mc {Opration}]
place .frame2.oper -x 0 -y 40
entry .frame2.op -width 1
place .frame2.op -x 70 -y 40
    
    label .frame2.lig -text [mc {n_lignes}]
    place .frame2.lig -x 95 -y 40
    entry .frame2.nlig -width 2
    place .frame2.nlig -x 150 -y 40
    label .frame2.col -text [mc {n_colonnes}]
    place .frame2.col -x 185 -y 40
    entry .frame2.ncol -width 2
    place .frame2.ncol -x 260 -y 40
    label .frame2.coupl -text [mc {couples}]
    place .frame2.coupl -x 0 -y 70
    entry .frame2.couples -width 60
    place .frame2.couples -x 0 -y 95
        label .frame2.scenario -text "[mc {parametres}] [.frame1.list1 get active] :"
        place .frame2.scenario -x 100 -y 10
	  button .frame2.aide -text [mc {Aide}]
	  place .frame2.aide -x 250 -y 305
	  bind .frame2.aide <1> "showaide {cmental}"

	  ###   " exec ${basedir}/$progaide ${basedir}/aide.html#cmental"
          ## "showaide  cmental"
        button .frame2.ajoutsc -text [mc {sauver_maj_scena}]
        place .frame2.ajoutsc -x 0 -y 220
	label .frame2.hasard -text [mc {choix_hasard_nombre}]
        place .frame2.hasard -x 0 -y 140
label .frame2.choix_max -text [mc {n_max}]
place .frame2.choix_max -x 0 -y 165
entry .frame2.n_max -width 4
place .frame2.n_max -x 150 -y 165
label .frame2.choix_n_couples -text [mc {n_couples}]
place .frame2.choix_n_couples -x 0 -y 190
entry .frame2.n_couples -width 4
place .frame2.n_couples -x 150 -y 190
set message1 "[mc {Puis}]:\n[mc {scena_choisi}]\n4) [mc {remplir_champ}]\n5) [mc {clic_sau_maj}]"
message  .frame2.consigne -text $message1 -foreground red    -aspect 300
place .frame2.consigne -x 0 -y 260

 bind .frame2.ajoutsc <ButtonRelease-1> "ajoutescenario"
bind .frame1.ajouter <ButtonRelease-1> "nouveauscenario"
bind .frame1.supprimer <ButtonRelease-1> "supprimescenario"
bind .frame1.list1 <Double-ButtonRelease-1> "capturelist1"
# les fichiers scnarios ont pour extension .sce
    set scenario ""
    set ext .sce
    set currentlist ""
# lister les scnarios exitant
proc teste_li { input} {
if  {[ regexp {(^[0-9]+$)} $input tout lig ] == 1 } {
			if { $input < 19 } {
			return $input
				} else {
			return 18
				}
            } else {
return 12
}
}
proc teste_co { input} {
if  {[ regexp {(^[0-9]+$)} $input tout  col] == 1 } {
       if { $input < 10 } {
            return $input
         } else {
         return 10
         }   
    } else {

return 2
}
}
proc teste_op { input} {
if  { [ regexp {^[\*|\-|\+|\/]$} $input ] } {
            return $input
    } else {
return "+"
}
}
proc teste_cou {liste} {
set li $liste
if { [expr [llength $li] % 2 ]  != 0 } {
set li [linsert  $li end  2] ; set liste $li
}
foreach el $liste {
if {![regexp {^([0-9]+[+|\-|*|\/]{0,1}\d*)+[+|\-|*|\/]{0,1}(\d*[+|\-|*|\/]{0,1}\d*)$} $el ]  } {
###![regexp {(^[0-9]+$)} $el ]
set indice [lsearch -exact $li $el]
set li [lreplace $li $indice $indice 1]
} 
}
return $li
}

proc peuplelist1 {} {
       global DOSSIER_EXOS  basedir choix_lieu DOSSIER_EXOS1    env Home
.frame1.supprimer configure  -state  normal
 .frame1.ajouter configure  -state  normal
 .frame2.ajoutsc configure  -state  normal
 if { $choix_lieu == "s" } {
  set DOSSIER_EXOS1  $DOSSIER_EXOS
} elseif {$choix_lieu == "u" } {
set DOSSIER_EXOS1  [file join $Home data ]
}  else {
set DOSSIER_EXOS1 [file join $basedir data]
 .frame1.supprimer configure  -state  disabled
 .frame1.ajouter configure  -state  disabled
 .frame2.ajoutsc configure  -state  disabled
}
cd $DOSSIER_EXOS1
      global ext
        .frame1.list1 delete 0 end
        catch {foreach i [lsort [glob [file join *$ext]]] {
                .frame1.list1 insert end [file rootname $i]
            }
        }
    }
 peuplelist1
# pour ajouter des noms de scnarios et en  mettre  jour la liste##############

proc nouveauscenario {} {
    global ext
    set scena [.frame1.text1 get]
    if {[catch {set f [open [file join $scena$ext] "w"]}]} {
        bell
        return
    } else {
        close $f
        peuplelist1
        set scena ""
        .frame1.text1 delete 0 end
    }
}
#pour supprimer un scnario et en mettre  jour la liste######

proc supprimescenario {} {
    global currentlist1 ext
    set scena [.frame1.text1 get]
    if {$scena==""} {
        bell
        return
    }

    catch {[file delete [file join $scena$ext]]}
    peuplelist1
   .frame1.text1 delete 0 end
}

#pour sauver un scnario mis  jour ou construit#################
proc fais_liste { oper ajout ou n_fois max } {
set liste {}
switch --  $oper {
		"+" {
		for {set i 1} {$i <= $n_fois }  { incr i} {
			if { $ou == "devant" } {
			lappend liste [expr int($max*(rand()))+ 1] $ajout
			} else {
			lappend liste $ajout [expr int($max*(rand()))+ 1]
			}
			}
			return $liste
			}
		 "-" {
		     for {set i 1} {$i <= $n_fois } { incr i} {
			if { $ou == "derriere" } {
			lappend liste $ajout [expr int($ajout*(rand()))+ 1]
			} else {
			lappend liste [expr int($max*(rand()))+ $ajout ] $ajout
			}
			}
			return $liste
			}
	   * {
		for {set i 1} {$i <= $n_fois }  { incr i} {
			if { $ou == "devant" } {
			lappend liste  [expr int($max*(rand()))+ 1] $ajout
			} else {
			lappend liste $ajout [expr int($max*(rand()))+ 1]
			}
			}
			return $liste
			}

		"/" {
			for {set i 1} {$i <= $n_fois } { incr i} {
			if { $ou == "devant" } {
		set liste	[concat $liste [ divise [expr int($max*(rand()))+ 1] $ajout $max "devant" ]]
# liste  [expr int($ajout*(rand()))+ 1] $ajout
			} else {
		set liste [concat $liste [ divise $ajout [expr int($ajout*(rand()))+ 1]  $max "derriere" ]]
#liste $ajout [expr int($max*(rand()))+ $ajout ]
			}
			}
			return $liste
			}

}
}
proc divise {n1 n2 nmax ou } {
if { [expr ($n1 % $n2)] == 0 } {
                 return [list $n1 $n2]
              }
 if { $ou == "devant" } {
return [ divise [expr int(${nmax}*(rand())) + 1] $n2 $nmax "devant" ]
	} else {
return [ divise $n1 [expr int(${nmax}*(rand())) + 1]  $nmax "derriere" ]

}
}


proc ajoutescenario {} {
    global ext  scenario ;# obtenu ds capturelist1
    if {[catch {set f [open [file join $scenario$ext] "w"]}]} {
        bell
        return
    } else {
     set inp [lindex [.frame2.couples get ] 0]
set oper [teste_op [.frame2.op get]] ; set n_lig [teste_li [.frame2.nlig get]]
set n_col [teste_co [.frame2.ncol get]]
.frame2.op delete 0 end ; .frame2.op insert 0 $oper
.frame2.nlig delete 0 end ; .frame2.nlig insert 0 $n_lig
.frame2.ncol delete 0 end ; .frame2.ncol insert 0 $n_col
    if { [regexp {^([0-9]+h|h[0-9]+)$} $inp ] != 1 } {
###set oper [teste_op [.frame2.op get]] ; set n_lig [teste_li [.frame2.nlig get]]
####set n_col [teste_co [.frame2.nlig get]]
 set couples [teste_cou [.frame2.couples get]]
  .frame2.couples  delete 0 end ; .frame2.couples insert 0 $couples
set data [list $oper $couples $n_lig $n_col]
#### [.frame2.couples get] [.frame2.nlig get] [.frame2.ncol get] ]
} else {
 	if { [string index $inp 0] == "h" } {
     set ou "devant" ; set ajout [string range $inp 1 [ expr [string length $inp] - 1] ]
    } else {
     set ou "derriere" ; set ajout [string range $inp 0 [ expr [string first "h" $inp]-1 ] ]
    }
#set ou "devant"
set data [list [.frame2.op get] [fais_liste [.frame2.op get] $ajout $ou [.frame2.n_couples get ] [.frame2.n_max get]] [.frame2.nlig get] [.frame2.ncol get] ]
.frame2.couples delete 0 end ; .frame2.couples insert 0 [lindex $data 1]
}
##.frame2.op delete 0 end ; .frame2.op insert 0 [lindex $data 0]
##.frame2.nlig delete 0 end ; .frame2.nlig insert 0 [lindex $data 2]
##.frame2.ncol delete 0 end ; .frame2.ncol insert 0 [lindex $data 3]

puts $f $data
close $f
        set currentlist1 ""
        set scenario ""
        .frame1.text1 delete 0 end
    }
}

#pour construire ou mettre  jour un scnario #################

proc capturelist1 {} {
    global currentlist1 ext scenario
    set scenario [.frame1.list1 get active]

catch {
    set f [open [file join $scenario$ext] "r"]
    set listdata [gets $f]
    close $f
#    set total [llength $listdata]
}
.frame2.op delete  0 end
.frame2.nlig delete 0 end
.frame2.ncol delete 0 end
.frame2.couples delete 0 end
if  { $listdata != "" } {
 ;#scnario existant
set oper [lindex  $listdata 0]
set listcouples [lindex $listdata 1]
set n_col [lindex $listdata 3]
set n_lig [lindex $listdata 2]
.frame2.op insert 0 $oper
.frame2.nlig insert 0 $n_lig
.frame2.ncol insert 0 $n_col
.frame2.couples insert 0 $listcouples
.frame2.scenario configure -text  "[mc {parametres}] [.frame1.list1 get active] :"
.frame2.ajoutsc configure -text "[mc {ajouter_maj_scena}] $scenario"
} else  {
     .frame2.scenario configure -text  "[mc {parametres}] [.frame1.list1 get active] :"
    .frame2.ajoutsc configure -text "[mc {ajouter_maj_scena}] $scenario"
}
}






