#!/bin/sh
#editeurseq.tcl
# Licence : GNU/GPL Version 2 ou plus
# \
exec wish "$0" ${1+"$@"}
#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#**************************************************************************
#  File  : $$$
#  Author  : jlsendral@free.fr
#  Modifier: 
#  Date    : 24/04/2002
#  Licence : GNU/GPL Version 2 ou plus
#
#  Description:
#  ------------
#
#  @version
#  @author     Jean-Louis Sendral
#  @modifier   Andre Connes
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
#
#  *************************************************************************


###################"gestion du son
#"global sound
#"if {[catch {package require -exact snack 2.1}]} {
#"    set sound 0
#"} else {
#"    set sound 1
#"}

# Construction des widgets de l'interface
# frame1(  doite !) pour modifier ou construire une squence et la sauver ########

set basedir [pwd]
source calculs.conf
source path.tcl
source i18n
set basedir [pwd]
# #########################################################################
# internationalisation (c) andre.connes@toulouse.iufm.fr
# le fichier i18n, inclus par la commande "source i18n", contient par exemple
#    set i18n(fr,hello) "Bonjour..."
#    set i18n(uk,hello) "Hello..."
# appel   : set message [gettext hello]
# ou bien : puts stdout [gettext hello]
# #########################################################################
#proc gettext { m } {
#  global LG i18n
#  if { [info exists i18n($LG,$m)] } {
#    return $i18n($LG,$m)
#  } elseif { [info exists i18n(fr,$m)] } {
#    return $i18n(fr,$m)
#  } else {
#    return "err.i18n_$LG : \"$m\" needed."
#  }
#} ;# proc gettext
. configure  -height 440 -width 640
##wm resizable . 0 0

if { [catch {package require Iwidgets}] == 1} {
tk_messageBox -message "Il est ncessaire d'installer le package Iwidgets pour que le menu aide fonctionne" -type ok -title "A nous les nombres"
}
proc showaide {signet} {
catch {
option add *textBackground seashell

set win [iwidgets::hyperhelp .#auto -title "Aide" -modality none -topics {aide}]
    $win showtopic aide#$signet
    $win activate
}
}
bind . <F1> "showaide cmental"
global sysFont
source msg.tcl
source fonts.tcl
wm geometry . +0+0 ; wm title . [mc {edit_seq}]

frame .frame1 -background #aaaaaa -height 440 -width 320
grid .frame1 -column 1 -row 0
listbox .frame1.list1 -background #c0c0c0 -height 10 -width 20  \
        -yscrollcommand ".frame1.scroll1 set"
scrollbar .frame1.scroll1 -command ".frame1.list1 yview"
place .frame1.list1 -x 90 -y 60
place .frame1.scroll1 -x 217 -y 60 -height 172
label .frame1.menu3 -text [mc {Double_clic_scena}] -background #aaaaaa
place .frame1.menu3 -x 65 -y 40
label .frame1.categorie -text [mc {Scnarios}]
place .frame1.categorie -x 130 -y 10
label .frame1.label1 -text [mc {liste_scena}] -background #aaaaaa
place .frame1.label1 -x 70 -y 240
button .frame1.ajouter -text  [mc {sauv_seq}]
place .frame1.ajouter -x 100 -y 290
set message1 "[mc {Puis}] :\n4) [mc {seq-choisie}]\n5) [mc {double_clic_sce}]\n6) [mc {double_clic_seq}]"
message  .frame1.consigne -text $message1 -foreground red  -aspect 300
place .frame1.consigne -x 35 -y 335

#"button .frame1.supprimer -text Supprimer
#"place .frame1.supprimer -x 100 -y 420
entry .frame1.text1 -width 30
place .frame1.text1 -x 60 -y 265
bind .frame1.list1 <Double-ButtonRelease-1> "ajout_scenario"
bind .frame1.ajouter <1> "sauver_sequence"

# frame2 pour ajouter un nom de squence, supprimer une squence########
#ou drouler une squence pour la modifier.#############
button .frame1.aide -text [mc {Aide}]
	  place .frame1.aide -x 275 -y 383
	  bind .frame1.aide <1> "showaide {cmental}"
 
	  ### "cd  $basedir ; exec $progaide  ./aide.html#cmental"
          
frame .frame2 -background #aaaaaa -height 440 -width 320
grid .frame2 -column 0 -row 0
listbox .frame2.list2 -background #c0c0c0 -height 10 -width 20  \
        -yscrollcommand ".frame2.scroll2 set"
scrollbar .frame2.scroll2 -command ".frame2.list2 yview"
place .frame2.list2 -x  85 -y 100
place .frame2.scroll2 -x 212 -y 100 -height 172
  label .frame2.t_reglage -text [mc {fich_syst_util}] -background #aaaaaa
place .frame2.t_reglage  -x 50 -y 30
radiobutton .frame2.reglages -variable choix_lieu -value s -text [mc {commun}] -background #aaaaaa -command "peuplelist1 ; peuplelist2"
place .frame2.reglages -x 30 -y 50
radiobutton .frame2.reglageu -variable choix_lieu -value u -text [mc {utilisateur}] -background #aaaaaa -command "peuplelist1 ; peuplelist2"
place .frame2.reglageu -x 113 -y 50
if { $tcl_platform(platform) == "windows" } {
.frame2.reglageu configure -state disable
}
radiobutton .frame2.reglagee -variable choix_lieu -value e -text [mc {exemple}] -background #aaaaaa -command "peuplelist1 ; peuplelist2"
place .frame2.reglagee -x 205 -y 50

.frame2.reglages select

label .frame2.menu3 -text [mc {double_clic_seq}] -background #aaaaaa
place .frame2.menu3 -x 60 -y 80
label .frame2.categorie -text [mc {sequences}]
place .frame2.categorie -x 130 -y 10
label .frame2.menu1 -text [mc {ajout_supp_seq}] -background #aaaaaa
place .frame2.menu1 -x 45 -y 282
entry .frame2.text2
place .frame2.text2 -x 90 -y 300

set message "1)[ mc {tap_seq}]\n2) [ mc {clic_ajsup}]\n3) [ mc {double_clic_nom}]"
message  .frame2.consigne -text $message -foreground red -aspect 300
place .frame2.consigne -x 50  -y 360




button .frame2.ajouter -text [mc {Ajouter}]
place .frame2.ajouter -x 60 -y 330
button .frame2.supprimer -text [mc {Supprimer}]
place .frame2.supprimer -x 180 -y 330
bind .frame2.ajouter <ButtonRelease-1> "ajout_sequence"
bind .frame2.supprimer <ButtonRelease-1> "supprime_sequence"
bind .frame2.list2 <Double-ButtonRelease-1> "montre_scenarios"

set scenario ""
set currentlist ""

#pour  lister les squences existantse
 proc peuplelist1 {} {
    global DOSSIER_EXOS basedir   env  DOSSIER_EXOS1  choix_lieu   Home
  .frame2.supprimer configure  -state  normal
 .frame2.ajouter configure  -state  normal
 .frame1.ajouter  configure  -state  normal
       if { $choix_lieu == "s" } {
  set DOSSIER_EXOS1  $DOSSIER_EXOS
} elseif  { $choix_lieu == "u" } {
set DOSSIER_EXOS1 [file join $Home data ]
}  else {
set DOSSIER_EXOS1 [file join $basedir data]
 .frame2.supprimer configure  -state  disabled
 .frame2.ajouter configure  -state  disabled
 .frame1.ajouter  configure  -state  disabled
}
cd $DOSSIER_EXOS1
set ext .seq
 ;#les fichiers squences ont pour extension .seq
    .frame2.list2 delete 0 end
    catch {foreach i [lsort [glob [file join *$ext]]] {
            .frame2.list2 insert end [file rootname $i]
        }
    }
cd $basedir
}
peuplelist1

#pour  lister les scnarios  existants
proc peuplelist2 {} {
   global DOSSIER_EXOS1  basedir   env      choix_lieu     DOSSIER_EXOS  Home
 if { $choix_lieu == "s" } {
  set DOSSIER_EXOS1  $DOSSIER_EXOS
} elseif  { $choix_lieu == "u" } {
set DOSSIER_EXOS1 [file join $Home data ]
} else {
 set DOSSIER_EXOS1 [file join $basedir data]
 }
cd $DOSSIER_EXOS1
set ext .sce
    .frame1.list1 delete 0 end
    catch {foreach i [lsort [glob [file join *$ext]]] {
            .frame1.list1 insert end [file rootname $i]
        }
    }
cd $basedir
}
peuplelist2

# pour insrer un scnario dans la squence
proc ajout_scenario {} {
.frame1.text1 insert end " "
.frame1.text1 insert end [.frame1.list1 get active]

}

# pour ajouter un nom de squence et en mettre  jour la liste.

proc ajout_sequence {} {
  global DOSSIER_EXOS1  basedir
cd $DOSSIER_EXOS1
 set sequence [.frame2.text2 get]
    set ext .seq
    if {[catch {set f [open [file join $sequence$ext] "w"]}]} {
        bell
        return
    } else {
    
        close $f
        peuplelist1
        .frame2.text2 delete 0 end
           }
cd $basedir
}

# pour supprimer une squence et en mettre  jour la liste.############

proc supprime_sequence {} {
global DOSSIER_EXOS1 basedir
cd $DOSSIER_EXOS1
set sequence [.frame2.text2 get]
set ext .seq
if {$sequence==""} {
    bell
    return
}
catch {[file delete [file join $sequence$ext]]}
peuplelist1
.frame2.text2 delete 0 end
cd $basedir
}

# pour lister les scnarios de la squence  modifier.###########

proc montre_scenarios {} {
   global DOSSIER_EXOS basedir DOSSIER_EXOS1
cd $DOSSIER_EXOS1
 set ext .seq   
    set sequence [.frame2.list2 get active]
       catch {
        set f [open [file join $sequence$ext] "r"]
        set listdata [gets $f]
        close $f
            }
    .frame1.text1 delete  0 end
    .frame1.text1 insert 0 $listdata
    .frame1.label1 configure -text "[mc {list_scena}] $sequence"
    .frame1.ajouter configure -text " [mc {sauv_seq}]$sequence"
cd $basedir
}

#pour sauver la squence modifie ou nouvelle.
proc sauver_sequence {} {
global DOSSIER_EXOS1 basedir
cd $DOSSIER_EXOS1
set ext .seq
set sequence [.frame2.list2 get active]
if {[catch {set f [open [file join $sequence$ext] "w"]}]} {
    bell
    return
} else {
    set data [.frame1.text1 get ]
    puts $f $data
    close $f
   .frame1.text1 delete  0 end
 }
cd $basedir
}




