#!/bin/sh
#pluie.tcl   ESSAI DE RECONSTRUCTION D'UN Logiciel IPT (auteur ?)
#\
exec wish "$0" ${1+"$@"}
###########################################################################
#*************************************************************************
#  Copyright (C) 2002 Eric Seigne <erics@rycks.com>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#**************************************************************************
#  File  : $$$
#  Author  : jean-louis.sendral@toulouse.iufm.fr
#  Modifier: 
#  Date    : 24/04/2002
#  Licence : GNU/GPL Version 2 ou plus
#
#  Description:
#  ------------
#
#  @version
#  @author     Jean-Louis Sendral
#  @modifier   
#  @project    Le terrier
#  @copyright  Eric Seigne 24/04/2002
#
#  *************************************************************************
set basedir [file dir $argv0]
cd $basedir
source calculs.conf
source i18n
source path.tcl
set basedir [pwd]
# #########################################################################
# internationalisation (c) andre.connes@toulouse.iufm.fr
# le fichier i18n, inclus par la commande "source i18n", contient par exemple
#    set i18n(fr,hello) "Bonjour..."
#    set i18n(uk,hello) "Hello..."
# appel   : set message [gettext hello]
# ou bien : puts stdout [gettext hello]
# #########################################################################
#proc gettext { m } {
#  global LG i18n
#  if { [info exists i18n($LG,$m)] } {
#    return $i18n($LG,$m)
#  } elseif { [info exists i18n(fr,$m)] } {
#    return $i18n(fr,$m)
#  } else {
#    return "err.i18n_$LG : \"$m\" needed."
#  }
#} ;# proc gettext

if { [catch {package require Iwidgets}] == 1} {
tk_messageBox -message "Il est ncessaire d'installer le package Iwidgets pour que le menu aide fonctionne" -type ok -title "A nous les nombres"
}

proc showaide {signet} {
catch {
option add *textBackground seashell

set win [iwidgets::hyperhelp .#auto -title "Aide" -modality none -topics {aide}]
    $win showtopic aide#$signet
    $win activate
}
}
bind . <F1> "showaide {}"
global sysFont , env  , DOSSIER_EXOS1
source msg.tcl
source fonts.tcl
set bgcolor #808080
set bgl #ff80c0
wm geometry . +0+0
. configure -background $bgcolor
##wm resizable . 0 0
wm  title . "[mc {cal_pluie}] - sous GPL"
set date [clock format [clock seconds] -format "%H%M%D"]

### outre frame, 3 autres cadres :
# .bframe,pour les calculs
# .mframe, pour le nom, score, test de debuggage
# .hframe pour la tombe des expressions par grid
catch {destroy .frame}
catch {destroy .bframe}
catch {destroy .mframe}
catch {destroy .hframe}
frame .frame -width 1024 -height 800 -background #808080
#bframe pour les calculs (bframe.res)
frame .bframe -background $bgcolor -relief raised -bd 3 -height 6
pack .bframe -side bottom -fill both
label .bframe.lab_consigne -background $bgcolor -text [mc {calc_somm_diff}]
grid .bframe.lab_consigne -padx 20 -column 1 -row 1
button .bframe.but_calcul -text [mc {lancer_calc}] \
-command ".bframe.but_calcul configure -state disable ; calcul"
grid .bframe.but_calcul -column 3 -row 1 -padx 100
entry .bframe.res -width 4  -textvariable rep  -font {arial 22}
grid .bframe.res -column 2 -row 1 ; 
#essai de bind control par return, mais ne sert  rien pour l'instant"
#bind .bframe.res <Keypress-Return>  [set rep1 [.bframe.res get]] ;#[set rep1 $rep]
#mframe pour le nom et le score et les tests de deboggage !!
frame .mframe -background $bgcolor -relief raised -bd 3
pack .mframe -side bottom -fill both 
#entry .mframe.ent_nom -width 20
#grid .mframe.ent_nom -column 1 -row 1 -sticky e
#label .mframe.lab_nom  -text "est   ton nom " -background #ffff80 -highlightcolor #aaff14 -anchor e
#grid .mframe.lab_nom -column 2 -row 1
set nom_elev  [lindex $argv 1 ] ;#init nom lve et nom clase
set nom_classe [lindex $argv 2 ]
initlog   $tcl_platform(platform)  $nom_elev
label .mframe.lab_nom  -text "[mc {bonjour}] $nom_elev" \
         -background #aaaaaa -highlightcolor #aaff14 -anchor e
  #AC# column 1 par 5
  grid .mframe.lab_nom -column 1 -row 1

#Initialisations fichier de calcul, nom de l'lve, nbre colonnes, de lignes
#set n_lig 10 ; set n_col 4

#.mframe.ent_nom insert end $nom_elev
#"set types {
#"    {"Catgories"		{.txt}	}
#"}
#"catch {set file [tk_getOpenFile -filetypes $types]}
#"if { [ catch { set f [open [file join $file] "r" ] } ] } {
#"set answer [tk_messageBox -message "Erreur de fichier" -type ok -icon info]
#"exit
#"}
#"if  {[file extension $fich] ==".sce" } {
#"set liste_sce [list $fich]
#"} else  {
#"set liste_sce [gets $f]
#"}
#"foreach exo  $liste_sce {
#"destroy .hframe   
#"   if {[file extension [lindex $liste_sce 0]] != ".sce" } {
#"set exo "${exo}.sce"
#"}
#"    set f [open [file join $exo ] "r"  ]

set fich [lindex $argv 0 ]
set choix_lieu    [lindex $argv 4 ]
    if { $choix_lieu == "s" } {
  set DOSSIER_EXOS1  $DOSSIER_EXOS
} 
if {$choix_lieu == "u" } {
set DOSSIER_EXOS1  [file join $env(HOME) leterrier calculs ]
}
if {$choix_lieu == "e" } {
set DOSSIER_EXOS1  [file join $basedir  data ]
}
cd  $DOSSIER_EXOS1
set f [open [file join $fich] "r"  ]
set listdata [gets $f] ;#init de la liste des couples.
#set fich $f
#"set fich [file tail $f]
close $f
cd $basedir
set oper [lindex  $listdata 0]
set n_lig [lindex  $listdata 2]
set n_col [lindex  $listdata 3]
if { $n_col > 9 } {
set n_col 8
}
if { $n_lig > 17 } {
set n_lig 17
}
proc traite_expr { expr} {
if { [string last + $expr] != -1  || [string last - $expr] != -1  \
 || [string last * $expr] != -1  || [string last \\ $expr] != -1 } {
return "\(${expr}\)"
} else {
return $expr
}
}
proc traite_expr1 {expr} {
 if { [string last "\(" $expr ] == -1  } {
 return $expr
    } else {
	return [expr $expr]
	}
}
#hframe pour la tombe des expressions.  par grid
frame .hframe -background #808080
pack .hframe -side bottom -fill both
for {set i 1} {$i <= $n_lig} {incr i 1} {
    for {set j 1} {$j <= $n_col} {incr j 1} {
        label .hframe.lab_bilan$i$j -text "_________"  -background #808080 -font {helvetica 20}
        grid .hframe.lab_bilan$i$j -column $j -row $i
    }}

label .hframe.rep -text "_________" -font {helvetica 20} ; grid .hframe.rep -column [expr $n_col + 4] -row 4 ;# essai pour les bad calculs
#"set listdata {+ {1 2 5 3 14 5 7 8 4 5 1 5 14 5 23 5 4 15 8 9 0 3 4 5  78 1}}
#init des couples de nombre en jeu, de l'opration, des couples au dpart
#des bons calculs et des mauvais

set listcouples [lindex $listdata 1] ; set oper [lindex $listdata 0]
set ndepart [expr int($n_col / 2) ]
#set ndepart 1; #< nbre colonnes -1  nbe de colonnes remplies au dpart
set listcouples [lindex $listdata 1]
set uu [llength $listcouples]
set nbrecouples [expr $uu /2]
for  {set i 0} {$i <= [expr 2*($ndepart - 1)]} {incr i 2 } { ;# ndepart couples  0  2 4 ie 1 3 5"  paramtrer
    set nx [traite_expr [lindex [lrange $listcouples  $i [expr  1 + $i]] 0] ]
    set ny [traite_expr [lindex [lrange $listcouples $i [expr 1 + $i ]] 1] ]
    set ii [expr ($i /2) + 1]
.hframe.lab_bilan1${ii}  configure -text "${nx}${oper}${ny}"  -background #808080 -font {helvetica 20}

 }
set listcouples [lrange $listcouples [expr 2*$ndepart] end]
set nbrecouplesrestant [expr $nbrecouples - $ndepart ]
set indexcol [expr $ndepart + 1]; #attention  ne pas dpasser $depart"
set score 0 ; set echec 0 ; set reussite 0 ; set mrep 0 ; set bonneliste {} ; set echecliste {} ;   set troptardliste {}
set tempo [lindex $argv 3] ; set drapeau_bon 0
#"destroy .hframe  #" de foreach
proc memorise {} {
global input
set input [.bframe.res get]
.bframe.res delete 0 end
}
proc solution { op b_lis t_lis e_lis  nom   fich  date } {
global env tcl_platform w2
catch {destroy .top2 }
set w2 [toplevel .top2]
wm geometry $w2 +0+0
wm title $w2 [mc {bil_bon_calc}]
###grab ${w2}
text ${w2}.text -yscrollcommand "${w2}.scroll set" -setgrid true -width 60 -height 15 \
 -wrap word -background black -font   {Helvetica  12}
scrollbar ${w2}.scroll -command "${w2}.text yview"
pack ${w2}.scroll -side right -fill y
pack ${w2}.text -expand yes -fill both
${w2}.text tag configure green -foreground green
${w2}.text tag configure red -foreground red
${w2}.text tag configure yellow -foreground yellow
${w2}.text tag configure normal -foreground black
${w2}.text tag configure white -foreground white -underline yes
 ${w2}.text tag configure white1 -foreground white     -font  {helvetica 16}
proc marge {} {
global w2
${w2}.text insert end  "   "
}

${w2}.text insert end  "  Le $date, exercice : $fich\n"     red
${w2}.text insert end   "[mc {resum}]  $nom :\n\n"   white1
marge ; ${w2}.text insert end  "[mc {bon_calc}]\n"   white
foreach cal $b_lis {
${w2}.text insert end "[mc {ton_calc}]  $cal =[expr $cal]\n" green
}
${w2}.text insert end  "\n"
marge ;  ${w2}.text insert end  "[mc {mauv_calc}]\n"   white
##foreach traite $elis
${w2}.text insert end "[mc {result_calc}]:\n" red
foreach cal [non_doublons $e_lis ]  {
${w2}.text insert end "  [lindex $cal 0]\-" red
}
##traitet_lis
${w2}.text insert end  "\n"
marge ; ${w2}.text insert end  "[mc {trop_tard}]\n"   white
    foreach cal $t_lis {
${w2}.text insert end "   $cal =[expr $cal]\n" yellow
}
  if  {  $tcl_platform(platform)  == "unix"  }  {
###after 1000
set rep [tk_messageBox  -message "[mc {imprim}]" -type yesno -icon question  -default no -title Imprimer? ]
 if {  $rep  == "yes"  }  {
### set  t    [ ${w2}.text  get  0.0  end  ]
 exec  lpr   <<  [ ${w2}.text  get  0.1  end  ]
 ###  $b_lis  $e_lis
 ### ${w2}.text  get  0 end  ]
 }
 }
}
proc non_doublons { liste} {
if { $liste == {} } {
return $liste
} else {
if { [lsearch [lrange $liste 1 end] [lindex $liste 0]] == -1 } {
    return [ list [lindex $liste 0] [ non_doublons [lrange $liste 1 end]] ]
   } else {
     return [non_doublons [lrange $liste 1 end]]
    }   
}
}
bind .bframe.res <Return> "memorise"
set input {}
##############################################################################################
# programme principal avec usage pseudo recursif. Rle de after pas trs clair encore
# A l'arrt : travail sauv ds un fichier qui doit exister
##############################################################################################
proc calcul {} {
global fich tempo nom_elev n_col n_lig listcouples nbrecouples score echec avreu reussite  \
mrep nbrecouplesrestant indexcol input oper  bonneliste echecliste troptardliste date bon_lig bon_col drapeau_bon
focus -force .bframe 
#"update
        if  { ( $echec == $nbrecouples ) || \
( $reussite >= $nbrecouples ) || \
( [expr $echec + $reussite] >= $nbrecouples )} {
#focus -force .mframe.ent_bilan
###.mframe.ent_bilan insert 0 $reussite 
label .mframe.lab_bilan  -text "$nom_elev, [mc {reussite}] $reussite calcul(s)." \
        -background #aaaaaa -highlightcolor #aaff14 -anchor e
    grid .mframe.lab_bilan -column 5 -row 1 -padx 10
    sauver $date $nom_elev $fich $oper $bonneliste $troptardliste  $mrep
 button .bframe.sol -text [mc {Rsum du travail ? }] -foreground yellow\
-command "solution $oper {$bonneliste} {$troptardliste}  {$echecliste} $nom_elev [file tail $fich]  $date"
 grid .bframe.sol -column 4 -row 1

  .bframe.but_calcul configure -text [mc {quitter}] -state active -command { exit }
return 1
        }
#            for  {set t 1} {$t <= $n_col} {incr t} {
#                .hframe.lab_bilan${n_lig}${t} configure -text "_______" -background #ffffff -font {helvetica 20}
#            }
        if  { ($nbrecouplesrestant != 0 ) && ($indexcol <= $n_col )  } {
            set acal [ lrange $listcouples 0 1 ]
            set listcouples [lrange $listcouples 2 end ]
            set nx [traite_expr [lindex $acal 0]] ; set ny [traite_expr [lindex $acal 1]]
            .hframe.lab_bilan1${indexcol}  configure -text "$nx$oper$ny"  -background #808080 -font {helvetica 20}
            incr indexcol ; if {$indexcol > $n_col } { set indexcol 1  } ;
            set nbrecouplesrestant [expr $nbrecouplesrestant - 1]
        } ;
#"        if {$indexcol > $n_col } { set indexcol 1  } ;
if { $drapeau_bon == 1} {
.hframe.lab_bilan${bon_lig}${bon_col}  configure -text "_________" -background #808080 -font {helvetica 20}
set drapeau_bon 0
}
set avreu $reussite ; avancer  ;
after $tempo  calcul     
 ; #"return 1
};
proc avancer {} {
global rep1 n_lig n_col bon_col bon_lig drapeau_bon listcouples nbrecouplesrestant oper \
 avreu reussite echec mrep score bonneliste echecliste indexcol input   troptardliste
focus  .bframe.res ;# redondant ?
set rep1 $input
###[.bframe.res get] 
if  {![ regexp {([0-9]+)} $rep1 ] == 1 } {
            set rep1 {}
}
# receuil de la rponse de l'lve. La dure de la frappe dpend de after 1500
# pour chaque case jusqu' la ligne n_lig-1 faire :
for  {set col 1 } {$col <= $n_col } {incr col } {
        set drap_bon 0
    for  {set lig [expr $n_lig - 1]} {$lig > 0 } {incr lig -1} {
        set val [.hframe.lab_bilan${lig}${col} cget -text] ; set lig_entree 0  ;# ce qu'il y a dans la case!
 ###traitement de val 45+56 ou(4+5)+56 ou...        
   if { [regexp {(\(?\d*[+|\-|*|\/]{0,1}\d*\)?)[+|\-|*|\/](\(?\d*[+|\-|*|\/]{0,1}\d*\)?)} $val tout prem deux]  } {      
            set nx2 [traite_expr1 $prem ] ; set ny2 [ traite_expr1 $deux ]
         set nx $prem  ; set ny $deux 
#".mframe.ent_nom insert 0 $oper ;.mframe.ent_nom insert 0 $nx ;.mframe.ent_nom insert 0 $ny ; # pour les tests
#  set som1 [expr $nx +$ny]
              if  { [expr $nx2 $oper $ny2] == $rep1 } { ; #bonne rponse. 
           #"clignote BRAVO $lig $col 10 ;
	    .bframe.res delete 0 end  ;# on efface la bonne rponse de l'input.
            incr score ; incr reussite ; #" .mframe.bil insert end $reussite
             set lig_entree $lig      ;  set drap_bon 1
set bonneliste [ linsert $bonneliste end  $tout]
# [list $prem $deux ]]
set bon_lig $lig ; set bon_col $col ; set drapeau_bon 1
.hframe.lab_bilan${lig}${col}  configure -text [mc {bon_calcul}]  -background #ffffff -font {helvetica 18}
if  { ($nbrecouplesrestant != 0)  && ([string compare .hframe.lab_bilan1${col} "_________" ] == 0 ) } {
    set acal [ lrange $listcouples 0 1 ]
    set listcouples [lrange $listcouples 2 end ]
    set nx1 [traite_expr [lindex $acal 0] ] ; set ny1 [traite_expr [lindex $acal 1]]
    set nbrecouplesrestant [expr $nbrecouplesrestant - 1]
    .hframe.lab_bilan1${col} configure -text "${nx1}${oper}${ny1}" -background #000000 -font {helvetica 20}
}
#".hframe.lab_bilan${lig}${col}  configure -text "___ " -background #808080 -font {helvetica 14}
##.bframe.res delete 0 end
set input {}
set col [expr $n_col + 1] ; break
	} else {
 #mauvaise rponse, on fait descendre! l'expression. echecliste ne sert pas
   if {  [.bframe.res get] != {} &&  $drap_bon  == 0 } {
    set echecliste [ linsert $echecliste end  [.bframe.res get] ]
    }
    set k [expr $lig + 1]
.hframe.lab_bilan${k}${col} configure -text "${prem}${oper}${deux}" -background #808080 -font {helvetica 20}
.hframe.lab_bilan${lig}${col}  configure -text "_________" -background #808080 -font {helvetica 20}
#.hframe.rep configure -text [mc {Mauvais calcul}] -font {helvetica 20}
set input {}
##.bframe.res delete 0 end ;# on efface la mauvaise rponse de l'input !.
		}

}
}
}
#il reste la dernire ligne : les trop tard !
for  {set t 1} {$t <= $n_col} {incr t} {
    set val [.hframe.lab_bilan${n_lig}${t} cget -text]
    if { [regexp {(\(?\d*[+|\-|*|\/]{0,1}\d*\)?)[+|\-|*|\/](\(?\d*[+|\-|*|\/]{0,1}\d*\)?)} $val tout prem deux] } {
               .hframe.lab_bilan${n_lig}${t} configure -text "[mc {trop_tard1}] " -background #ffffff -font {helvetica 20}
             incr echec
#    set nx [traite_expr [ lindex [split $val $oper] 0] ]
#    set ny  [traite_expr [ lindex [split $val $oper] 1 ]]
    set troptardliste [ linsert $troptardliste end  $tout]
    ##[list $prem $deux ] ]
      if  { ($nbrecouplesrestant != 0 ) && ($t != $indexcol) } {
        set acal [ lrange $listcouples 0 1 ]
        set listcouples [lrange $listcouples 2 end ]
        set nx [traite_expr [lindex $acal 0]] ; set ny [traite_expr [lindex $acal 1]]
        .hframe.lab_bilan1${t}  configure -text "$nx${oper}$ny"  -background #808080 -font {helvetica 20}
        set nbrecouplesrestant [expr $nbrecouplesrestant - 1]
     }
}
}
# si le nbe de reussites est inchang c'est une mauvaise rponse sinon bonne rponse.
#essai de mentionner un mauvais calcul : non concluant !
if  { $avreu == $reussite && $rep1 != "" } {
	incr mrep 
.hframe.rep configure -text "${mrep} [mc {echecs}] " -font {helvetica 20}
###clignote "${mrep} [mc {echecs}]"  5
} else  {
   .hframe.rep configure -text "_________" -font {helvetica 20}

}
return 1
}

proc clignote {texte  nclic} {
 for  {set cl 1} {$cl <= $nclic} {incr cl} {
.hframe.rep  configure -text "  $texte "  -background red -font {helvetica 14}
after 30
update
after 30
.hframe.rep  configure -text "  $texte "  -background green -font {helvetica 14}
update}
}
# sauver les rsultats
proc sauver {dat nom fic oper listereussite troptard mrep} { ; #  scuriser
global savingFile nom_classe TRACEDIR user env  choix_lieu LogHome
cd $TRACEDIR
#set types {
#    {"Catgories"		{.txt}	}
#}
#catch {set file [tk_getSaveFile -filetypes $types]}
#set f [open [file join $file] "a"]
#set travail  "date : $dat nom : $nom fichier : $fic $oper bon : $listereussite echec : $listechec  mauvais cal : $badcal"
set basefile [file tail $fic]
#set savingFile ${nom_classe}.bil
#  catch {set f [open [file join $savingFile] "a"]}
#  set travail  ":$dat:$nom:$basefile de  ${choix_lieu}:$oper:$listereussite:$troptard:$mrep:$LogHome:pl"
#puts $f $travail
#close $f
catch {set flog  [open [file join $user] "a+"]}
set log "$dat: $nom : [file tail ${fic}] de ${choix_lieu} :$oper:$listereussite:$troptard:$mrep:pl"
puts  $flog $log
close $flog
##exec   /usr/bin/leterrier_log  --message=$log   --logfile=$user
}









